package simpledb;

/** Unique identifier for HeapPage objects. */
public class HeapPageId implements PageId {

    // <silentstrip lab1>
    int tableId;
    int pgNo;
    // </silentstrip>

    /**
     * Constructor. Create a page id structure for a specific page of a
     * specific table.
     *
     * @param tableId The table that is being referenced
     * @param pgNo The page number in that table.
     */
    public HeapPageId(int tableId, int pgNo) {
        // <strip lab1>
        this.tableId = tableId;
        this.pgNo = pgNo;
        // </strip>
    }


    /** @return the table associated with this PageId */
    public int tableid() {
        // <strip lab1>
        return tableId;
        // </strip>
        // <insert lab1>
        // return 0;
        // </insert>
    }

    /**
     * @return the page number in the table tableid() associated with
     *   this PageId
     */
    public int pageno() {
        // <strip lab1>
        return pgNo;
        // </strip>
        // <insert lab1>
        // return 0;
        // </insert>
    }

    /**
     * @return a hash code for this page, represented by the concatenation of
     *   the table number and the page number (needed if a PageId is used as a
     *   key in a hash table in the BufferPool, for example.)
     * @see BufferPool
     */
    public int hashCode() {
        // <strip lab1>
        int code = (tableId << 16) + pgNo;
        return code;
        // </strip>
        // <insert lab1>
        // throw new UnsupportedOperationException("implement this");
        // </insert>
    }

    /**
     * Compares one PageId to another.
     *
     * @param o The object to compare against (must be a PageId)
     * @return true if the objects are equal (e.g., page numbers and table
     *   ids are the same)
     */
    public boolean equals(Object o) {
        // <strip lab1>
        if (!(o instanceof HeapPageId))
            return false;
        HeapPageId p = (HeapPageId)o;
        return tableId == p.tableId && pgNo == p.pgNo;
        // </strip>
        // <insert lab1>
        // return false;
        // </insert>
    }

    /**
     *  Return a representation of this object as an array of
     *  integers, for writing to disk.  Size of returned array must contain
     *  number of integers that corresponds to number of args to one of the
     *  constructors.
     */
    public int[] serialize() {
        // <strip lab1|lab2|lab3|lab4>
        int data[] = new int[2];

        data[0] = tableId;
        data[1] = pgNo;

        return data;
        // </strip>
        // <insert lab1|lab2|lab3|lab4>
        // // Not necessary for lab 1, 2, or 3
        // return null;
        // </insert>
    }

}
